From fec6efece6eab77c835da518cf3d76be70400570 Mon Sep 17 00:00:00 2001
From: Feng Shu <tumashu@163.com>
Date: Wed, 10 Nov 2021 16:10:37 +0800
Subject: [PATCH] xwidget: Add xwidget-webkit-buffer-name-format.

* lisp/xwidget.el (xwidget-webkit-buffer-name-prefix): Rename from ...
(xwidget-webkit-buffer-name-format):  to this.
(xwidget-webkit-callback): Use xwidget-webkit-buffer-name-format instead.

* etc/NEWS: Note xwidget-webkit-buffer-name-format.
---
 etc/NEWS        |  2 +-
 lisp/xwidget.el | 14 +++++++++-----
 2 files changed, 10 insertions(+), 6 deletions(-)

diff --git a/etc/NEWS b/etc/NEWS
index 3cad0995ac..56f5ac486f 100644
--- a/etc/NEWS
+++ b/etc/NEWS
@@ -504,7 +504,7 @@ This is a convenience function to extract the field data from
 ** Xwidgets
 
 ---
-*** New user option 'xwidget-webkit-buffer-name-prefix'.
+*** New user option 'xwidget-webkit-buffer-name-format'.
 This allows the user to change the webkit buffer names.
 
 +++
diff --git a/lisp/xwidget.el b/lisp/xwidget.el
index 905327083b..54ae36e547 100644
--- a/lisp/xwidget.el
+++ b/lisp/xwidget.el
@@ -95,8 +95,10 @@ xwidget-webkit
   :group 'web
   :prefix "xwidget-webkit-")
 
-(defcustom xwidget-webkit-buffer-name-prefix "*xwidget-webkit: "
-  "Buffer name prefix used by `xwidget-webkit' buffers."
+(defcustom xwidget-webkit-buffer-name-format "*xwidget-webkit: %T*"
+  "Buffer name format used by `xwidget-webkit' buffers.
+Format specs supported:
+1. %T -- title of web page."
   :type 'string
   :version "29.1")
 
@@ -372,9 +374,11 @@ xwidget-webkit-callback
                  ;; Do not adjust webkit size to window here, the
                  ;; selected window can be the mini-buffer window
                  ;; unwantedly.
-                 (rename-buffer (concat xwidget-webkit-buffer-name-prefix
-                                        title "*")
-                                t)))))
+                 (rename-buffer
+                  (format-spec
+                   xwidget-webkit-buffer-name-format
+                   `((?T . ,title)))
+                  t)))))
           ((eq xwidget-event-type 'decide-policy)
            (let ((strarg  (nth 3 last-input-event)))
              (if (string-match ".*#\\(.*\\)" strarg)
-- 
2.30.2

